#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_VipDesc.h"
std::auto_ptr<M_VipDesc> M_VipDesc::msSingleton(nullptr);

int M_VipDesc::GetCount()
{
	return (int)mMapData.size();
}

const M_VipDescData* M_VipDesc::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_VipDescData>& M_VipDesc::GetMapData()
{
	return mMapData;
}

void M_VipDesc::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_VipDesc.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_VipDescData data;
		data.mID = element->IntAttribute("ID");
		data.mVipLevel = element->IntAttribute("VipLevel");
		data.mNewContent = element->IntAttribute("NewContent");
		data.mDesc = element->Attribute("Desc");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_VipDesc Loaded. Load Data:%u", mMapData.size());
}

void M_VipDesc::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_VipDesc");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_VipDesc");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_VipDescData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "VipLevel", data.mVipLevel);
		LuaCfgHelper::readInt(L, "NewContent", data.mNewContent);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_VipDesc Loaded. Load Data:%u", mMapData.size());
}

void M_VipDesc::Reload()
{
	mMapData.clear();
	Load();
}

M_VipDesc* M_VipDesc::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_VipDesc());
	}
	return msSingleton.get();
}

void M_VipDesc::Release()
{
	msSingleton.reset(nullptr);
}
